<?php
// $Id$

require_once('/usr/share/simplesamlphp-aai/lib/_autoload.php');
$as = new SimpleSAML_Auth_Simple('default-sp');
if(!isset($_GET["logout"])){
	$as->requireAuth();
}

session_write_close();

require_once('../../config.php');

if(isset($_GET["logout"])){
    simplesaml_logout($as);
}
elseif(isguestuser()) {
    simplesaml_init($as);
}
elseif(!isloggedin()) {
    simplesaml_init($as);
}
else{
    redirect($CFG->wwwroot);
}

function simplesaml_logout($as) {
	global $CFG, $PAGE, $OUTPUT;

	$type = optional_param('type', 0, PARAM_INT);

	if($type == 1){
		if($as->isAuthenticated()) {
			$as->logout($CFG->wwwroot);
			redirect($CFG->wwwroot);
		}
		redirect($CFG->wwwroot);
	}

	//redirect($CFG->wwwroot);

	$context = context_system::instance();
	$PAGE->https_required();
    $PAGE->set_context($context);
	$PAGE->set_pagelayout('login');
	$PAGE->set_url('/auth/simplesaml/index.php');

	$PAGE->set_title(get_string('logout_title', 'auth_simplesaml'));
	$PAGE->set_heading(get_string('logout_title', 'auth_simplesaml'));

	echo $OUTPUT->header();
	echo $OUTPUT->heading(get_string('logout_title', 'auth_simplesaml'));
	echo $OUTPUT->notification(get_string('logout_success', 'auth_simplesaml'));
	echo $OUTPUT->notification(get_string('logout_info', 'auth_simplesaml'));
	echo $OUTPUT->continue_button(new moodle_url($CFG->wwwroot.'/auth/simplesaml/index.php', array('logout' => 1, 'type' => 1)));

	echo $OUTPUT->footer();
}


function simplesaml_init($as) {
    global $CFG, $USER, $SESSION;

    $GLOBALS['simplesaml_login'] = TRUE;
    $attributes = $as->getAttributes();
	$attributes['hrEduPersonUniqueID'][0] = strtolower($attributes['hrEduPersonUniqueID'][0]);
    $GLOBALS['simplesaml_login_attributes'] = $attributes;

    $user = authenticate_user_login($attributes['hrEduPersonUniqueID'][0], time());
	
	//Odkomentirati ako želite prijavu samo s Vaše domene. Moguće je omogućiti pristup i dodatnim domenama dodavanjem vrijednosti u matricu, npr. $allowed = array('domain.hr', 'srce.hr');
	/*$allowed = array('domain.hr');
    $domain = array_pop(explode('@', $attributes['hrEduPersonUniqueID'][0]));
    if(!in_array($domain, $allowed)){
        throw new moodle_exception('Pravo pristupa sustavu imaju samo nastavnici i studenti ustanove XYZ.');
    }*/

    $USER = complete_user_login($user);
    $USER->loggedin = true;
    $USER->site = $CFG->wwwroot;

    update_user_login_times();
    set_login_session_preferences();

    $SESSION->justloggedin = true;
    add_to_log(SITEID, 'user', 'login', "view.php?id=$USER->id&course=".SITEID, $USER->id, 0, $USER->id);
    //check_enrolment_plugins($USER);
    load_all_capabilities();

    if (user_not_fully_set_up($USER)) {
    	$urltogo = $CFG->wwwroot.'/user/edit.php?id='.$USER->id.'&amp;course='.SITEID;
    }
    else{
    	$urltogo = $CFG->wwwroot.'/';
    	unset($SESSION->wantsurl);
    }

    if(!has_capability('moodle/site:config',get_context_instance(CONTEXT_SYSTEM)) and !empty($CFG->mymoodleredirect)) {
    	if($urltogo == $CFG->wwwroot or $urltogo == $CFG->wwwroot.'/' or $urltogo == $CFG->wwwroot.'/index.php') {
    		$urltogo = $CFG->wwwroot.'/my/';
    	}
    }

    unset($SESSION->wantsurl);
    redirect($urltogo);
}

?>
